/*
 * client_basic_app.c  ieee1888 sdk client 使用示例
 * author: Lubia Yang
 * create: 2013-8-10
 * update: 2013-9-25
 */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "client_basic.h"

/*
 * demo功能：创建3个point，每个point創建2条数据
 * 各数据结构参见client_basic.h与ieee1888.h
 */
void write_to_server() {
	int p_count = 8; //指定point数量

    char *serverUrl="http://www.ioe1888.com/axis3/services/IOE1888Storage?wsdl";  
	write_point pBuffer[p_count];
	strcpy(pBuffer[0].point_id, "http://biigroup.com/room/2501/VA0");
	strcpy(pBuffer[1].point_id, "http://biigroup.com/room/2501/VA1");
	strcpy(pBuffer[2].point_id, "http://biigroup.com/room/2501/VA2");
	strcpy(pBuffer[3].point_id, "http://biigroup.com/room/2501/VA3");
	strcpy(pBuffer[4].point_id, "http://biigroup.com/room/2501/VA4");
	strcpy(pBuffer[5].point_id, "http://biigroup.com/room/2501/VAS0");
	strcpy(pBuffer[6].point_id, "http://biigroup.com/room/2501/VAS1");
	strcpy(pBuffer[7].point_id, "http://biigroup.com/room/2501/VAT");	
	int i = 0;
	for (i = 0; i < p_count; i++) {
		int n_value = 1;//指定point的数据条数
		pBuffer[i].n_value = n_value;
		pBuffer[i].p_value = (ieee1888_write_ext*) calloc(sizeof(ieee1888_write_ext), n_value);
		int k = 0;
		for (k = 0; k < n_value; k++) {
			pBuffer[i].p_value[k].time = time(NULL);		
			 int value = (int)( 26.0 *rand()/(RAND_MAX + 1.0));
			 printf("%d\n",value);
			 char content[3];
			 sprintf(content,"%d",value);
                        // printf("----------222\n");
                        // printf("----------- %s\n",content);
                        // printf("----------- %s\n",pBuffer[i].p_value[k].content);
		        pBuffer[i].p_value[k].content=(char*)malloc(3); 
                        strcpy(pBuffer[i].p_value[k].content,content);
                       // pBuffer[i].p_value[k].content="22";
                       // printf("---------111\n");
		}
	}
	int result = IEEE1888_ClientBaiscWrite(serverUrl, pBuffer, p_count);
	for (i = 0; i < p_count; i++) {
		free(pBuffer[i].p_value);
	}
	if (!result) {
		printf("write seccessful !\n");
	} else {
		printf("write fail !\n");
	}
}

/*
 * demo功能：打印查询到的数据
 */
void deal_with_result(fetch_point *pBuffer, int pCount) {
	int i = 0;
	for (i = 0; i < pCount; i++) {
		int n = pBuffer[i].n_value;
		int k = 0;
		printf("%s: \n", pBuffer[i].point_id);
		for (k = 0; k < n; k++) {
			printf("%s  ", (pBuffer[i].p_value[k].time));
			printf("%s  \n", (pBuffer[i].p_value[k].content));
		}
		//释放内存
		IEEE1888_DestoryObject(pBuffer[i].p_value, n);
	}
}

/*
 * demo功能：从服务端查询指定point的数据
 * 各数据结构参见client_basic.h与ieee1888.h
 */
void fetch_from_server() {
	int p_count = 1;//指定查询point的数量
	char *serverUrl = "http://www.ioe1888.com/axis3/services/IOE1888Storage?wsdl";//指定服务端地址
	//char *serverUrl = "http://10.1.1.132:1888/IEEE1888GW";
	fetch_point pBuffer[p_count];

	strcpy(pBuffer[0].point_id, "http://biigroup.com/room/2501/VA0");//指定point id

	pBuffer[0].select = 0; //0 最新值，1 最旧值，2 指定范围

	int result = IEEE1888_ClientBaiscFetch(serverUrl, pBuffer, p_count);

	if (!result) {
		printf("fetch seccessful !\n");
		deal_with_result(pBuffer, p_count);
	} else {
		printf("fetch fail !\n");
	}
}

int main() {
	//write_to_server();
	fetch_from_server();
	//for (;;) {write_to_server(); sleep(1);fetch_from_server(); sleep(1);}
	//for (;;) {fetch_from_server(); sleep(1);}
	//for (;;)
	//{write_to_server(); sleep(10);}
}
