#ifndef	IEEE1888UNI_CLIENTBASIC_H_H_H
#define IEEE1888UNI_CLIENTBASIC_H_H_H

#include "ieee1888.h"

#define MAX_POINT_ID_LEN 256
#define MAX_CONTENT_LEN 256
#define MAX_TIME_LEN 32


typedef struct basic_point {
	char point_id[MAX_POINT_ID_LEN];//要查询对象的ID
	int  select;   					//0:查询最大值，1:查询最小值
									//2:指定查询范围
	char pGt[MAX_TIME_LEN];  		//大于某值
	char pLt[MAX_TIME_LEN];  		//小于某值
}basic_point;

typedef struct ieee1888_write_ext {
	time_t time;		//数据写入时间
	char*  content;		//数据值
}ieee1888_write_ext;

typedef struct ieee1888_value_ext {
	char*  time; 		//数据写入时间
	char*  content;		//数据值
}ieee1888_value_ext;

typedef struct fetch_point {
	char point_id[MAX_POINT_ID_LEN];//要查询对象的ID
	int  select;   					// 0:查询最大值，1:查询最小值，2:指定查询范围
	char pGt[MAX_TIME_LEN];  		//大于某值
	char pLt[MAX_TIME_LEN];  		//小于某值
	  	
	int n_value;  					//此ID查询结果的数量
	ieee1888_value_ext *p_value;	//此ID的查询结果
}fetch_point;

typedef struct write_point {
	char point_id[MAX_POINT_ID_LEN];//上报的管控点ID
	int n_value;				    //点上报的数据条数
	ieee1888_write_ext *p_value; 	//点上报的数据内容
}write_point;

typedef struct point_value{
	int n_value;  					//此ID查询结果的数量
	char point_id[MAX_POINT_ID_LEN];//点的ID
	ieee1888_value_ext *p_value;	//此ID的查询结果
}point_value;

typedef struct points_from_soap{
	int n_point;		//point点的数量
	point_value *point; //指向point数组的指针
}points_from_soap;

typedef struct trap_point {  
	char  point_id[MAX_POINT_ID_LEN];	//要查询对象的ID
	int tll;							//设置该query在Provider处的生存时间，单位为秒
	char callbackData[MAX_POINT_ID_LEN];//当数据与查询匹配时，数据发送的目标组件的URI
}trap_point;

typedef int (*operation) (points_from_soap* pBuffer);

int IEEE1888_ClientBaiscFetch(char *serverUrl,fetch_point *pBuffer,int pCount); 

int IEEE1888_ClientBaiscWrite(char *serverUrl,write_point *pBuffer,int pCount);

int IEEE1888_DestoryObject(ieee1888_value_ext* p_value,int n_value);

int IEEE1888_SoapGenerator(basic_point *pBuffer,int pCount,char *send_msg,int msg_len);

int IEEE1888_SoapClient(char *serverUrl,char *send_msg,char* recv_msg,int msg_len);

int IEEE1888_SoapParse(points_from_soap **points,char* recv_msg);

int IEEE1888_DestoryPoints(points_from_soap *points);

int IEEE1888_ClientBasicTrap(char *serverUrl, trap_point *pBuffer, int pCount, operation CallData);
 
#endif
