#ifndef	IEEE1888UNI_SERVERBASIC_H_H_H
#define IEEE1888UNI_SERVERBASIC_H_H_H

#include "ieee1888.h"
#define FAULT_CODE_LEN 32
#define FAULT_STRING_LEN 128

typedef struct fetch_points {
	int n_key;
	ieee1888_key* key;
} fetch_points;

typedef struct points_value {
	int n_point;
	ieee1888_point* point;
} points_value;

typedef struct fault {
	char fault_code[FAULT_CODE_LEN];
	char fault_string[FAULT_STRING_LEN];
} fault;

typedef points_value* (*query_handler)(fetch_points* request);
typedef int (*data_handler)(points_value* request);
typedef void (*fault_handler)(fault* fault);

void IEEE1888_DataPoolWrite(char* path, points_value* ps);
points_value* IEEE1888_DataPoolFetch(char* path, fetch_points* fetch);
void IEEE1888_SetServerHandler(query_handler query, data_handler data, fault_handler fault);
int IEEE1888_ServerCreate(int port);

#endif
